/* \[XTv
   BCDXCb`ŖڕWdݒ肷B
   PWMo͌ARꂽdADCŎ擾AڕWlƔr鎖PWMɗpp[^XVAo͓d𐧌䂷B
   ڕWd1.8~3.3vɂẮAꂽp[^e[uŗpӂiȊO͗_ljB
   VXeNbNɂPLL16MHzgpB
   FUSECKSEL"0001"ݒ肷鎖iDefault:0010j
*/

//BCDXCb`_̏ꍇɗLɂ}N
// #define INVERTED_SW

#define PWM_RESOLUTION 8

// Turn Off̍Œۏ؊
#define PWM_H_MIN 0
// TCCR0A[0]
#define WGM00 0
// System Clock Setting (for util/delay.h)
#define F_CPU 16000000UL  // 16 MHz

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


/****** Global Variable Defination *****/

// ݂̃^[Qbgd(index)
volatile uint8_t tgt_vol ;
// ADCʂi[
volatile uint8_t adcval ;
// PWM"H"ԕ
volatile uint8_t pwm_high_width ;
// PWM
volatile uint8_t pwm_cycle;
// PWM̃NbN
volatile uint8_t pwm_div ;
// ADC̃NbN
volatile uint8_t adc_div ;
// ADCڕWl
volatile uint8_t adc_target ;


// ^[Qbgdlɂ茈肷ep[^
struct pwm_information {
	uint8_t pwm_cycle ;
	uint8_t target ;
	uint8_t pwm_div ;
	uint8_t adc_div ;
}  ;	

// ADC Clock Division
#define ADC_DIV_2 0
#define ADC_DIV_4 _BV(ADPS1)
#define ADC_DIV_8 _BV(ADPS1)|_BV(ADPS0)

// PWM Clock Division
#define PWM_DIV_1 _BV(CS10)
#define PWM_DIV_2 _BV(CS11)
#define PWM_DIV_4 _BV(CS11)|_BV(CS10)

// 18~33lɂāAindexɕϊ
#define SUPPORT_VOLTAGE(val) val-18

// BCD̓͒l10iɕϊe[u
const uint8_t sw_value_table[] = {
	  0,   1,   2,   3,   4,   5,   6,   7,   8,   9, 0,0,0,0,0,0,	// 0x0*
	 10,  11,  12,  13,  14,  15,  16,  17,  18,  19, 0,0,0,0,0,0,	// 0x1*
	 20,  21,  22,  23,  24,  25,  26,  27,  28,  29, 0,0,0,0,0,0,	// 0x2*
	 30,  31,  32,  33,  34,  35,  36,  37,  38,  39, 0,0,0,0,0,0,	// 0x3*
	 40,  41,  42,  43,  44,  45,  46,  47,  48,  49, 0,0,0,0,0,0,	// 0x4*
	 50,  51,  52,  53,  54,  55,  56,  57,  58,  59, 0,0,0,0,0,0,	// 0x5*
	 60,  61,  62,  63,  64,  65,  66,  67,  68,  69, 0,0,0,0,0,0,	// 0x6*
	 70,  71,  72,  73,  74,  75,  76,  77,  78,  79, 0,0,0,0,0,0,	// 0x7*
	 80,  81,  82,  83,  84,  85,  86,  87,  88,  89, 0,0,0,0,0,0,	// 0x8*
	 90,  91,  92,  93,  94,  95,  96,  97,  98,  99, 0,0,0,0,0,0,	// 0x9*
} ;


const struct pwm_information pwm_info[] = {		//	[v]		[Hz]
	{ 240,   91, PWM_DIV_2, ADC_DIV_4 }, 	// 1.80		 320.5
	{ 240,   97, PWM_DIV_2, ADC_DIV_4 }, 	// 1.92		 381.7
	{ 240,  102, PWM_DIV_2, ADC_DIV_2 }, 	// 1.98v	 729.9
	{ 240,  109, PWM_DIV_2, ADC_DIV_2 }, 	// 2.11v	 411.5
	{ 240,  113, PWM_DIV_2, ADC_DIV_2 }, 	// 2.23v	 130k <
	{ 240,  120, PWM_DIV_2, ADC_DIV_2 }, 	// 2.32
	{ 239,  125, PWM_DIV_2, ADC_DIV_2 }, 	// 2.38		130k <
	{ 240,  128, PWM_DIV_2, ADC_DIV_2 }, 	// 2.52		130k <
	{ 240,  132, PWM_DIV_2, ADC_DIV_2 }, 	// 2.62		130k <
	{ 240,  139, PWM_DIV_2, ADC_DIV_2 }, 	// 2.70		130k <
	{ 238,  143, PWM_DIV_2, ADC_DIV_2 }, 	// 2.79
	{ 220,  150, PWM_DIV_2, ADC_DIV_2 }, 	// 2.91		1163
	{ 220,  157, PWM_DIV_2, ADC_DIV_2 }, 	// 3.01		 650.3
	{ 204,  160, PWM_DIV_2, ADC_DIV_4 }, 	// 3.09		130k <
	{ 200,  160, PWM_DIV_2, ADC_DIV_4 }, 	// 3.20		 684.9
	{ 200,  168, PWM_DIV_2, ADC_DIV_4 }, 	// 3.30		 561.8
} ;


#define SUPPORT_PWM_CYCLE  pwm_info[SUPPORT_VOLTAGE(tgt_vol)].pwm_cycle
#define SUPPORT_PWM_DIV    pwm_info[SUPPORT_VOLTAGE(tgt_vol)].pwm_div
#define SUPPORT_ADC_TARGET pwm_info[SUPPORT_VOLTAGE(tgt_vol)].target
#define SUPPORT_ADC_DIV    pwm_info[SUPPORT_VOLTAGE(tgt_vol)].adc_div

#define DEFAULT_PWM_CYCLE  240
#define DEFAULT_PWM_DIV    PWM_DIV_2
#define DEFAULT_ADC_TARGET tgt_vol*5 ;
#define DEFAULT_ADC_DIV    ADC_DIV_2

/* ============================================ */
/* Setting Routine                              */
/* ============================================ */

inline void
set_pwm_parameter(void)
{
	if((18<=tgt_vol)&&(tgt_vol<=33)) {
		pwm_cycle  = SUPPORT_PWM_CYCLE ;
		pwm_div    = SUPPORT_PWM_DIV ;
		adc_div    = SUPPORT_ADC_DIV ;
		adc_target = SUPPORT_ADC_TARGET ;
	}
	else {
		pwm_cycle  = DEFAULT_PWM_CYCLE ;
		pwm_div    = DEFAULT_PWM_DIV ;
		adc_div    = DEFAULT_ADC_DIV ;
		adc_target = DEFAULT_ADC_TARGET ;
	}
}


/* ============================================ */
/* Interrupt Block Start                        */
/* ============================================ */

// PWM Cycle Term Overflow Interrupt
ISR (TIMER1_OVF_vect)
{
	// PWMp̍XV
    TCCR1B = (TCCR1B&0xf0) | pwm_div ;

	// PWM̍XV
	OCR1C = pwm_cycle ;

	// update PWM Compare Value
    OCR1B = pwm_high_width ;
}

// ADC Complete Interrupt
ISR(ADC_vect)
{
	//ADC result
	uint8_t  diff ;
	//XCb`͒l(10i)
	uint8_t sw_dat ;

#if defined INVERTED_SW
	sw_dat = sw_value_table[(~PINA) & 0xff] ;
#else
	sw_dat = sw_value_table[PINA] ;
#endif

	// MAX 4.9v
	if(sw_dat>=50) sw_dat = 49 ;
	if(sw_dat!=tgt_vol) {
		tgt_vol = sw_dat ;
		set_pwm_parameter() ;
	}

	adcval = ADCH ;  // ADC Data[9:2]

	// ADCʂڕWlႯ΁APWMHighԁiSwitch-Offjk
	if(adcval < adc_target) {
		diff = adc_target-adcval ;
		pwm_high_width = (pwm_high_width>diff)? pwm_high_width-diff: 0 ;
   }
	// ADCʂڕWl荂΁APWMHighԁiSwitch-Offjg
	else if(adcval > adc_target) {
		diff = adcval-adc_target ;
		pwm_high_width = (diff<(pwm_cycle-pwm_high_width))? pwm_high_width+diff: pwm_cycle ;
	}
	
	//ADCp̍XV
	ADCSRA = (ADCSRA&0xf8) | adc_div ;

	//start ADC
	ADCSRA |= _BV(ADSC);
}


/* ============================================ */
/* Function Initialize Block Start              */
/* ============================================ */

void
init_io (void)
{
	//Pull Up PortA[0:7] 
    PORTA = 0xff ;
	//PortA[0:7] data direction set to "IN"
    DDRA = 0x00 ;
	//PortB[0:2](Reserved for ISP) and PortB[5:6](no use) set to "OUT"
	DDRB |= _BV(DDB0) | _BV(DDB1) | _BV(DDB2) | _BV(DDB5) | _BV(DDB6) ;
}


void
init_pwm (void)
{
	// enable PLL
	PLLCSR = _BV(PLLE) ;
	_delay_us(100) ;
	// poll PLL Clock Ready
	loop_until_bit_is_set(PLLCSR, PLOCK) ;
	//enable PCK (Timer1 Clock Source: 64MHz Interrnal Clock)
	PLLCSR |= _BV(PCKE) ;
	// PWM.
	OCR1C = pwm_cycle ;
	// PWM"H"
    OCR1B = pwm_high_width;
	// OC1A: no use
	// OC1B: set to PWM mode and clear on Compare-match.
    TCCR1A = (  _BV(PWM1B) | _BV(COM1B1) ) ;
	//PortB.3(OC1B) data direction set to "OUT"
    DDRB |= _BV (DDB3);
	// enable Timer/Counter1 Overflow Interrupt.
    TIMSK |= _BV (TOIE1);
}


void
init_adc(void)
{
	// Vref:             Internal 2.56V
	// adjust Result:    Data to Left.
	// Analog Input:     PB4
	// ADC Auto Trigger: Free Run
	ADMUX =  _BV(REFS1) | _BV(ADLAR) | _BV(MUX2) | _BV(MUX1) |_BV(MUX0) ;
	ADCSRB = _BV(REFS2) ;
	
	//PortB.4(ADC7) data direction set to "IN"
    DDRB &= ~_BV(DDB4);
	
	// enable ADC
	// disable Auto Trigger
	ADCSRA =  _BV(ADEN) | adc_div ;
}


/* -----------------------------------*/

int
main (void)
{
	// ^[Qbgd̏lݒ
	tgt_vol = 0x00 ;
	set_pwm_parameter() ;
	pwm_high_width=0 ;
	
	// System Clock Divider set to 1x.
	CLKPR = _BV(CLKPCE) ;
	CLKPR = 0 ;
	
	// Initialize Start
	init_io  () ;
	init_pwm () ;
	init_adc () ;
    // SEt Interrupt enable. (defined in "interrupt.h")
	sei ();

	// start PWM
    TCCR1B = pwm_div ;
	
	// start ADC
	ADCSRA |= _BV(ADIE);  // enable ADC interrupt
	ADCSRA |= _BV(ADSC);  // start ADC
	
	while(1) {}
	return (0);
}
